function [W, E] = LMS2(X, d, M, mu, varargin)
% LMS 算法 ,返回滤波器加权系数矩阵和误差向量。算法从接收到第M个实数数据时开始运行。
%
% 调用格式
% [W, E] = LMS(X,d,M,mu,W0)
%      E= 存储在整个迭代过程中滤波器输出和d(n)的误差变化情况,为行向量
%      W= 滤波器的加权参量序列,为一矩阵,其每行贮存一个加权参量在整个迭代过程中的变化情况
%         该矩阵的最后一列为滤波器加权系数的最终值
%      X= 输入信号，列向量
%      d= 期望信号，列向量
%      M= 滤波器阶数
%     mu= 步长
%     W0= 滤波器加权系数的初始值，默认值为零向量
% 
% 作者: 张智林
% 版本: v1.0
% 最后修改于2005年2月6日 
%
% 参考:
%     何振亚,自适应信号处理,P31,科学出版社





% 输入的变量个数
vin = length(varargin); 
Item = vin+4;                        

% 当输入变量为5个时,接受输入的加权系数的初始值
% 当输入变量为4个时，加权系数取默认值(零向量)
if Item == 5                                        
    W = varargin{1}* ones(1,M-1);
else 
    W = zeros(M,1)* ones(1,M-1);
end

% 为误差向量预留存储空间
E = zeros(1, size(X,1));

% 运行算法。算法从接收到第M个数据时开始运行
for k = M : size(X,1)                                
    x_tap = X(k: -1 : k-M+1);
    E(k) = d(k) - W(:, k-1)'* x_tap;
    W(:,k) = W(:, k-1) + 2 * mu * E(k) * x_tap;
end
